import {expect} from 'chai';
import {capitalize} from "../../lib/utils/string";

/**
 * Checks auto generated functions on targets prototype
 */
export function expectAutoGeneratedFunctions(target: any,
                                             keys: {singular: string; plural?: string}): void {

  const prefixes: {[type: string]: {singular: string[], plural: string[]}} = {
    toMany: {
      singular: ['create', 'remove', 'has'],
      plural: ['add', 'count', 'get', 'set', 'remove', 'has']
    },
    toOne: {
      singular: ['create', 'get', 'set'],
      plural: []
    }
  };

  const finalPrefixes = prefixes[keys.plural ? 'toMany' : 'toOne'];

  Object
    .keys(keys)
    .forEach(key => {

      finalPrefixes[key].forEach(prefix => {

        expect(target.prototype)
          .to.have.property(prefix + capitalize(keys[key]))
          .that.is.a('function');
      });
    });
}
